Package io.vertx.core.http

## Interface WebSocketBase

- All Superinterfaces:
    `ReadStream<Buffer>`, `StreamBase`, `WriteStream<Buffer>`
  All Known Subinterfaces:
    `ClientWebSocket`, `ServerWebSocket`, `WebSocket`

      public interface WebSocketBase
      extends ReadStream<Buffer>, WriteStream<Buffer>

  Base WebSocket implementation.

  It implements both `ReadStream` and `WriteStream` so it can be used with `Pipe` to pipe data with flow control.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `binaryHandlerID()` | When a `WebSocket` is created, it may register an event handler with the event bus - the ID of that handler is given by this method.
    `WebSocketBase` | `binaryMessageHandler​(Handler<Buffer> handler)` | Set a binary message handler on the connection.
    `default Future<Void>` | `close()` | Close the WebSocket sending the default close frame.
    `default Future<Void>` | `close​(short statusCode)` | Close the WebSocket sending a close frame with specified status code.
    `default Future<Void>` | `close​(short statusCode, String reason)` | Close sending a close frame with specified status code and reason.
    `WebSocketBase` | `closeHandler​(Handler<Void> handler)` | Set a close handler.
    `String` | `closeReason()` | Returns the close reason message from the remote endpoint or `null` when not yet received.
    `Short` | `closeStatusCode()` | Returns the close status code received from the remote endpoint or `null` when not yet received.
    `WebSocketBase` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `Future<Void>` | `end()` | Ends the stream.
    `WebSocketBase` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `WebSocketBase` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `WebSocketBase` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `WebSocketBase` | `frameHandler​(Handler<WebSocketFrame> handler)` | Set a frame handler on the connection.
    `WebSocketBase` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `MultiMap` | `headers()` | Returns the HTTP headers.
    `boolean` | `isClosed()` |
    `boolean` | `isSsl()` |
    `SocketAddress` | `localAddress()` |
    `WebSocketBase` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `List<Certificate>` | `peerCertificates()` |
    `WebSocketBase` | `pongHandler​(Handler<Buffer> handler)` | Set a pong frame handler on the connection.
    `SocketAddress` | `remoteAddress()` |
    `WebSocketBase` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `WebSocketBase` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `default Future<Void>` | `shutdown()` | Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout, the status code `1000` a `null` reason.
    `default Future<Void>` | `shutdown​(long timeout, TimeUnit unit)` | Calls `shutdown(long, TimeUnit, short, String)` with the status code `1000` and a `null` reason.
    `default Future<Void>` | `shutdown​(long timeout, TimeUnit unit, short statusCode)` | Calls `shutdown(long, TimeUnit, short, String)` with a `null` reason.
    `Future<Void>` | `shutdown​(long timeout, TimeUnit unit, short statusCode, String reason)` | Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.
    `default Future<Void>` | `shutdown​(short statusCode)` | Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout and a `null` reason.
    `default Future<Void>` | `shutdown​(short statusCode, String reason)` | Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout.
    `WebSocketBase` | `shutdownHandler​(Handler<Void> handler)` | Set a `handler` notified when the WebSocket is shutdown: the client or server will close the connection within a certain amount of time.
    `SSLSession` | `sslSession()` |
    `String` | `subProtocol()` | Returns the WebSocket sub protocol selected by the WebSocket handshake.
    `String` | `textHandlerID()` | When a `WebSocket` is created, it may register an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `WebSocketBase` | `textMessageHandler​(Handler<String> handler)` | Set a text message handler on the connection.
    `Future<Void>` | `writeBinaryMessage​(Buffer data)` | Writes a (potentially large) piece of binary data to the connection.
    `Future<Void>` | `writeFinalBinaryFrame​(Buffer data)` | Write a final WebSocket binary frame to the connection
    `Future<Void>` | `writeFinalTextFrame​(String text)` | Write a final WebSocket text frame to the connection
    `Future<Void>` | `writeFrame​(WebSocketFrame frame)` | Write a WebSocket frame to the connection
    `Future<Void>` | `writePing​(Buffer data)` | Writes a ping frame to the connection.
    `Future<Void>` | `writePong​(Buffer data)` | Writes a pong frame to the connection.
    `Future<Void>` | `writeTextMessage​(String text)` | Writes a (potentially large) piece of text data to the connection.

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `collect, pipe, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, write, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          WebSocketBase exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          WebSocketBase handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          WebSocketBase pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          WebSocketBase resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          WebSocketBase fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          WebSocketBase endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          WebSocketBase setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          WebSocketBase drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryHandlerID

          String binaryHandlerID()

      When a `WebSocket` is created, it may register an event handler with the event bus - the ID of that handler is given by this method.

      By default, no handler is registered, the feature must be enabled via `WebSocketConnectOptions.setRegisterWriteHandlers(boolean)` or `HttpServerOptions.setRegisterWebSocketWriteHandlers(boolean)`.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Returns:
        the binary handler id
      See Also:
        `WebSocketConnectOptions.setRegisterWriteHandlers(boolean)`, `HttpServerOptions.setRegisterWebSocketWriteHandlers(boolean)`

    - #### textHandlerID

          String textHandlerID()

      When a `WebSocket` is created, it may register an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      By default, no handler is registered, the feature must be enabled via `WebSocketConnectOptions.setRegisterWriteHandlers(boolean)` or `HttpServerOptions.setRegisterWebSocketWriteHandlers(boolean)`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Returns:
        the text handler id
      See Also:
        `WebSocketConnectOptions.setRegisterWriteHandlers(boolean)`, `HttpServerOptions.setRegisterWebSocketWriteHandlers(boolean)`

    - #### subProtocol

          String subProtocol()

      Returns the WebSocket sub protocol selected by the WebSocket handshake.

      On the server, the value will be `null` when the handler receives the WebSocket callback as the handshake will not be completed yet.

    - #### closeStatusCode

          Short closeStatusCode()

      Returns the close status code received from the remote endpoint or `null` when not yet received.

    - #### closeReason

          String closeReason()

      Returns the close reason message from the remote endpoint or `null` when not yet received.

    - #### headers

          MultiMap headers()

      Returns the HTTP headers.
      Returns:
        the headers

    - #### writeFrame

          Future<Void> writeFrame​(WebSocketFrame frame)

      Write a WebSocket frame to the connection
      Parameters:
        `frame` - the frame to write
      Returns:
        a future completed with the result

    - #### writeFinalTextFrame

          Future<Void> writeFinalTextFrame​(String text)

      Write a final WebSocket text frame to the connection
      Parameters:
        `text` - The text to write
      Returns:
        a future completed with the result

    - #### writeFinalBinaryFrame

          Future<Void> writeFinalBinaryFrame​(Buffer data)

      Write a final WebSocket binary frame to the connection
      Parameters:
        `data` - The data to write
      Returns:
        a future completed with the result

    - #### writeBinaryMessage

          Future<Void> writeBinaryMessage​(Buffer data)

      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeTextMessage

          Future<Void> writeTextMessage​(String text)

      Writes a (potentially large) piece of text data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Parameters:
        `text` - the data to write
      Returns:
        a future completed with the result

    - #### writePing

          Future<Void> writePing​(Buffer data)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the ping frame has been successfully written

    - #### writePong

          Future<Void> writePong​(Buffer data)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the pong frame has been successfully written

    - #### closeHandler

          WebSocketBase closeHandler​(Handler<Void> handler)

      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `closeStatusCode()` will return the status code and `closeReason()` will return the reason.
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### shutdownHandler

          WebSocketBase shutdownHandler​(Handler<Void> handler)

      Set a `handler` notified when the WebSocket is shutdown: the client or server will close the connection within a certain amount of time. This gives the opportunity to the `handler` to close the WebSocket gracefully before the WebSocket is forcefully closed.
      Parameters:
        `handler` - the handler notified with the remaining shutdown
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          WebSocketBase frameHandler​(Handler<WebSocketFrame> handler)

      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          WebSocketBase textMessageHandler​(Handler<String> handler)

      Set a text message handler on the connection. This handler will be called similar to the `binaryMessageHandler(Handler)`, but the buffer will be converted to a String first
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          WebSocketBase binaryMessageHandler​(Handler<Buffer> handler)

      Set a binary message handler on the connection. This handler serves a similar purpose to `handler(Handler)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame.isFinal()` to find the boundaries).
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### pongHandler

          WebSocketBase pongHandler​(Handler<Buffer> handler)

      Set a pong frame handler on the connection. This handler will be invoked every time a pong frame is received on the server, and can be used by both clients and servers since the RFC 6455 section 5.5.2 and section 5.5.3 do not specify whether the client or server sends a ping.

      Pong frames may be at most 125 bytes (octets).

      There is no ping handler since ping frames should immediately be responded to with a pong frame with identical content

      Pong frames may be received unsolicited.

      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          Future<Void> end()

      Ends the stream.

      Once the stream has ended, it cannot be used any more. Calls `close()`

      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### close

          default Future<Void> close()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.
      Returns:
        a future completed with the result

    - #### close

          default Future<Void> close​(short statusCode)

      Close the WebSocket sending a close frame with specified status code. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Parameters:
        `statusCode` - the status code
      Returns:
        a future completed with the result

    - #### close

          default Future<Void> close​(short statusCode,
                                     String reason)

      Close sending a close frame with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Parameters:
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed with the result

    - #### shutdown

          default Future<Void> shutdown()

      Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout, the status code `1000` a `null` reason.

    - #### shutdown

          default Future<Void> shutdown​(short statusCode)

      Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout and a `null` reason.

    - #### shutdown

          default Future<Void> shutdown​(short statusCode,
                                        String reason)

      Like `shutdown(long, TimeUnit, short, String)` with a 30 seconds timeout.

    - #### shutdown

          default Future<Void> shutdown​(long timeout,
                                        TimeUnit unit)

      Calls `shutdown(long, TimeUnit, short, String)` with the status code `1000` and a `null` reason.

    - #### shutdown

          default Future<Void> shutdown​(long timeout,
                                        TimeUnit unit,
                                        short statusCode)

      Calls `shutdown(long, TimeUnit, short, String)` with a `null` reason.

    - #### shutdown

          Future<Void> shutdown​(long timeout,
                                TimeUnit unit,
                                short statusCode,
                                String reason)

      Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.

      The WebSocket is closed with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1
      Parameters:
        `timeout` - the amount of time after which all resources are forcibly closed
        `unit` - the of the timeout
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed when shutdown has completed

    - #### remoteAddress

          SocketAddress remoteAddress()

      Returns:
        the remote address for this connection, possibly `null` (e.g a server bound on a domain socket). If `useProxyProtocol` is set to `true`, the address returned will be of the actual connecting client.

    - #### localAddress

          SocketAddress localAddress()

      Returns:
        the local address for this connection, possibly `null` (e.g a server bound on a domain socket) If `useProxyProtocol` is set to `true`, the address returned will be of the proxy.

    - #### isSsl

          boolean isSsl()

      Returns:
        true if this `HttpConnection` is encrypted via SSL/TLS.

    - #### isClosed

          boolean isClosed()

      Returns:
        `true` if the WebSocket cannot be used to send message anymore

    - #### sslSession

          SSLSession sslSession()

      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.
      See Also:
        `SSLSession`

    - #### peerCertificates

          List<Certificate> peerCertificates()
                                      throws SSLPeerUnverifiedException

      Returns:
        an ordered list of the peer certificates. Returns null if connection is not SSL.
      Throws:
        `SSLPeerUnverifiedException` - SSL peer's identity has not been verified.
      See Also:
        `()`, `sslSession()`